﻿
var VPAdminHTML5Directives = angular.module('VPAdminHTML5Directives', []);

//SelectDisplays TreeGrid Directive
VPAdminHTML5Directives.directive('onFinishRender', function ($timeout) {
    return {
        restrict: 'A',
        link: function (scope, element, attr) {
            if (scope.$last === true) {
                $timeout(function () {
                    scope.$emit('ngRepeatFinished');
                });
            }
        }
    }
});

VPAdminHTML5Directives.directive('onFinishSecurity', function ($timeout) {
    return {
        restrict: 'A',
        link: function (scope, element, attr) {
            if (scope.$last === true) {
                $timeout(function () {
                    scope.$emit('ngRepeatSecurityFinished');
                });
            }
        }
    }
});

VPAdminHTML5Directives.directive('onFinishPermissionGrid', function ($timeout) {
    return {
        restrict: 'A',
        link: function (scope, element, attr) {
            if (scope.$last === true) {
                $timeout(function () {
                    scope.$emit('onFinishPermissionGrid');
                });
            }
        }
    }
});

VPAdminHTML5Directives.directive('onFinishDisplay', function ($timeout) {
        return {
            restrict: 'A',
            link: function (scope, element, attr) {
                if (scope.$last === true) {
                    $timeout(function () {
                        scope.$emit('ngRepeatSecureDisplayFinished');
                    });
                }
            }
        }
});

VPAdminHTML5Directives.directive('setScroll', function ($timeout) {
        return {
            restrict: 'A',
            link: function (scope, element, attr) {
                if (scope.$last === true) {
                    $timeout(function () {
                        var position = parseInt(localStorage['scrollposition'] || '0');
                        $('#scrollSelectDisplays').scrollTop(position);
                    });
                }
            }
        }
});

VPAdminHTML5Directives.directive('customState', function () {
    return {
        require: '?ngModel',
        link: function (scope, el, attrs, ctrl) {
            var truthy = true;
            var falsy = false;
            var nully = null;
            ctrl.$formatters = [];
            ctrl.$parsers = [];  
            ctrl.$render = function () {                
                var d = ctrl.$viewValue;               
                el.data('checked', d);
                switch (d) {
                    case truthy:
                        el.prop('indeterminate', false);
                        el.prop('checked', true);
                        break;
                    case falsy:
                        el.prop('indeterminate', false);
                        el.prop('checked', false);
                        break;
                    default:
                        el.prop('indeterminate', true);
                }
                
            };
            el.bind('click', function (e) {
                if (document.getElementById('gridPermissionList').disabled) return;
                var d;
                switch (el.data('checked')) {
                    case falsy:
                        d = truthy;
                        break;
                    case truthy:
                        d = nully;
                        break;
                    default:
                        d = falsy;
                }
                var role = el[0].dataset.identifier;
                var property = el[0].dataset.property;
                var security = ViewPoint.Client.VPAdmin.Security.GetSecurityClass();
                security.ctrlSecuredDisplays.gridPermissionList_SelectionChanged(role, property, d);              
                scope.$apply(ctrl.$render);
                e.preventDefault();
            });
        }
    };
});

VPAdminHTML5Directives.directive('raTree', ['$compile', function ($compile) {
    return {
        restrict: 'A',
        link: function ( scope, element, attrs ) {
            //tree id
            var treeId = attrs.treeId;
			
            //tree model
            var treeModel = attrs.raTree;

            //node id
            var nodeId = attrs.nodeId || 'id';

            //node label
            var nodeLabel = attrs.nodeLabel || 'label';

            //children
            var nodeChildren = attrs.nodeChildren || 'children';

            var nodeFullName = attrs.nodeFullname;

            var first = attrs.nodeFirst == "true";
            var repeat = first? 'set-scroll': '';
            var dbleClick =  CurrentBrowser.browserName() === 'IE' ? ' ng-dblclick="dblclick(node)" ' : ''; 
            var dbleClickMobileEnable =  CurrentBrowser.browserName() === 'IE' ? ' ng-dblclick="dblclickmobileenable(node)" ' : ''; 
            //tree template
           var template =
                    '<li ng-repeat="node in ' + treeModel + '" ' + repeat + '>' +
                        '<input type="checkbox" ng-show="node.' + nodeChildren + '.length" class="expander" checked>' +
                        '<span class="expander" ng-show="node.' + nodeChildren + '.length"></span>' +
                        '<div style=" left: 40px; height: 25px; border-right:1px solid #dddddd; position: absolute; " />' +
                        '<input type="checkbox" id="{{node.FullName}}" isIndeterminate="{{node.isIndeterminate}}" isSelect="{{node.Selected}}" class="check" ng-model="node.Selected"' + dbleClick + 'ng-click="onSelectedChanged(node,node.Selected, node.' + nodeChildren + '.length)">' +
                        '<div style=" left: 100px;  height: 25px; border-right:1px solid #dddddd; position: absolute; " />' +
                        '<input type="radio" ng-hide="node.' + nodeChildren + '.length"  name="initialDisplay" value="{{node.FullName}}" ng-disabled="!node.Selected" ng-model="node.IsInitialDisplay" ng-click="onRadioClickedByUser(node)" style=" left: 63px;  position: absolute; margin-top: 4px;">' +
                        '<div style=" left: 155px; height: 25px; border-right:1px solid #dddddd; position: absolute; " />' +
                        '<input type="checkbox" id="M_{{node.FullName}}" isMobileIndeterminate="{{node.isMobileIndeterminate}}" isSelect="{{node.MobileEnable}}" ng-disabled="!node.Selected" class="check" ng-model="node.MobileEnable"' + dbleClickMobileEnable + 'ng-click="onMobileEnableChanged(node,node.MobileEnable, node.' + nodeChildren + '.length, true)"  style="left: 122px;  position: absolute; margin-top: 4px;">' +
                        '<label style="white-space:pre" class="normal" isFolder="{{node.isFolder||false}}">{{node.' + nodeLabel + '}}</label>' +
                        '<ul class="css-treeview" data-tree-id="' + treeId + '" ra-tree="node.' + nodeChildren + '" data-node-id=' + nodeId + ' data-node-label=' + nodeLabel + ' data-node-children=' + nodeChildren + ' style="margin-left: 10px;"></ul>' +
                    '</li>';

            //check tree id, tree model
            if( treeId && treeModel ) {
                //Rendering template.
                element.html('').append( $compile( template )( scope ) );
            }
        }
    };
}]);

VPAdminHTML5Directives.directive('raTreeSecuredDisplay', ['$compile', function ($compile) {
    return {
        restrict: 'A',
        link: function ( scope, element, attrs ) {
            
            //tree model
            var treeModel = attrs.raTreeSecuredDisplay;

            //call directive on finish repeat when is the first child
            var first = attrs.nodeFirst == "true";

            //tree template
            var repeat = first? 'on-finish-display': '';

            var path = attrs.path || '';

            var template =
                     '<li ng-repeat="area in ' + treeModel + '" ' +  repeat + '>' +
                        '<input type="checkbox" ng-show="area.children.length" class="expander" checked>' +
                        '<span class="expander" ng-show="area.children.length"></span>' +                      
                        '<label path="' + path + '/{{area.Name}}" isFolder="{{area.isFolder||false}}" data-xml="{{area.FullXMLPath}}" style="white-space:pre" ng-class="{0:\'nomalFont\'}[area.children.length]" ng-click="treeApp_SelectedItemChanged(area.Name, $event)">{{area.Name}}</label>' +
                        '<ul class="css-treeview" ra-tree-secured-display="area.children" path="' + path + '/{{area.Name}}" style="margin-left: 10px;"></ul>' +
                    '</li>';

            //check tree id, tree model
            if(treeModel) {
                //Rendering template.
                element.html('').append( $compile( template )( scope ) );
            }
        }
    };
}]);